<!DOCTYPE html>
<html>

<head>
  <meta name="viewport" content="width=device-width, initial-scale=1">
  <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.6.0/jquery.min.js"></script>
  <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/css/bootstrap.min.css">
  <script src="https://maxcdn.bootstrapcdn.com/bootstrap/4.5.2/js/bootstrap.min.js"></script>
  <script src="https://code.jquery.com/jquery-3.6.4.js" integrity="sha256-a9jBBRygX1Bh5lt8GZjXDzyOB+bWve9EiO7tROUtj/E="
    crossorigin="anonymous"></script>
</head>

<body>
  <div class="container">
    <h2>Registration Car Form</h2>

    <div class="jumbotron container">
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-fname">First Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-fname" name="firstname" placeholder="Your first name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="input-lname">Last Name</label>
        </div>
        <div class="col-sm-9">
          <input type="text" id="input-lname" name="lastname" placeholder="Your last name ..." class="form-control">
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="country-select">Country</label>
        </div>
        <div class="col-sm-3">
          <select id="country-select" name="country" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="region-type-select">Region</label>
        </div>
        <div class="col-sm-3">
          <select id="region-type-select" name="region" class="form-control">
          </select>
        </div>
      </div>
      <div class="row form-group">
        <div class="col-sm-3">
          <label for="car-select">Car</label>
        </div>
        <div class="col-sm-3">
          <select id="car-select" name="car" class="form-control">
          </select>
        </div>
        <div class="col-sm-3">
          <label for="car-type-select">Car type</label>
        </div>
        <div class="col-sm-3">
          <select id="car-type-select" name="car-type" disabled class="form-control">
          </select>
        </div>
      </div>
      <div class="row">
        <div class="col-sm-12" style="text-align: right;">
          <button class="btn btn-info" id="btn-send"> Send </button>
        </div>
      </div>
    </div>
  </div>
</body>

<script>
  "use strict";
  /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
  // car brand information
  var gJsonCarData = `[
                          {"brandId": "0","brandName": "None", "brandTypes": []}, 
                          {"brandId": "1","brandName": "Audi", "brandTypes": [{"typeId":"0", "typeName":"Q3"},{"typeId":"1","typeName":"Q5"},{"typeId":"2","typeName":"A4"}]},
                          {"brandId": "2","brandName": "BMW", "brandTypes": [{"typeId":"0","typeName":"1 series"},{"typeId":"1","typeName":"X series"},{"typeId":"2","typeName":"Z series"}]},
                          {"brandId": "3","brandName": "Citroen", "brandTypes": [{"typeId":"0","typeName":"new C3"},{"typeId":"1","typeName":"C4"},{"typeId":"2","typeName":"BERLINGO"}]}
                        ]`;

  // country information
  var gJsonCountryData = `[
                            {"countryId": "0","countryName": "None", "regionTypes": []}, 
                            {"countryId": "1","countryName": "Việt nam", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0", "regionName":"Hà Nội"},
                                                                          {"regionId":"1","regionName":"Hồ Chí Minh"},
                                                                          {"regionId":"2","regionName":"Đà Nẵng"}]},
                            {"countryId": "2","countryName": "Mỹ", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Atlanta"},
                                                                          {"regionId":"1","regionName":"New York"},
                                                                          {"regionId":"2","regionName":"Boston"}
                                                                        ]},
                            {"countryId": "3","countryName": "Phần lan", "regionTypes": 
                                                                        [
                                                                          {"regionId":"0","regionName":"Nam Phần Lan"},
                                                                          {"regionId":"1","regionName":"Tây Phần Lan"},
                                                                          {"regionId":"2","regionName":"Đông Phần Lan"}
                                                                        ]}
                          ]`;

  var gObjectCarData = JSON.parse(gJsonCarData);

  /*** REGION 2 - Vùng gán / thực thi sự kiện cho các elements */
  $(document).ready(function () {
    onPageLoadDing();
  });
  //
  $("#car-select").on("change", function () {
    onSelectCarChange(this);
  })
  $("#btn-send").click(function () {
    onBtnSendClick();
  })

  /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
  function onPageLoadDing() {
    loadDataSelectCar();
  }
  //
  function onSelectCarChange(paramBrandId) {
    var vSelect = $(paramBrandId).val();
    console.log(vSelect);
    //
    dataToSelectType(vSelect);
  }

  //
  function onBtnSendClick() {
    var vFormObjCar =
    {
      brandId: -1,
      brandName: "",
      typeId: -1,
      typeName: "",
    }
    thuThapDuLieu(vFormObjCar);
    var vDuLieuHopLe = valiDateSend(vFormObjCar);
    if(vDuLieuHopLe)
    {
      showDataCar(vFormObjCar);
    }
  }
  /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình*/
  function loadDataSelectCar() {
    var vSelectCar = $("#car-select");
    for (var bI = 0; bI < gObjectCarData.length; bI++) {
      $("<option/>", {
        "value": gObjectCarData[bI].brandId,
        "text": gObjectCarData[bI].brandName
      }).appendTo(vSelectCar); // appendTo con add vao cha
    }
  }
  //
  function dataToSelectType(paramType) {
    // load du lieu cho brandtype
    var vBrandTypes = getBrandTypeByBrandID(paramType);
    // reset select data type
    var vCarSelectType = $("#car-type-select")
      .html("");
    // set enable/disable cho type select car
    if (vBrandTypes == 0) {
      vCarSelectType.prop("disabled", "disabled");
    }
    else {
      vCarSelectType.prop("disabled", false);
    }
    // load du lieu vao select car type
    for (var bI = 0; bI < vBrandTypes.length; bI++) {
      $("<option/>", {
        "value": vBrandTypes[bI].typeId,
        "text": vBrandTypes[bI].typeName
      }).appendTo(vCarSelectType);
    }
  }

  /**
   * get brandType by brandId
   * input: brandId of a car
   * output: brandType name of found car. If not found, it returns null
   */
  function getBrandTypeByBrandID(paramBrandId) {
    var vBrandFound = false;
    var vBrandTypesResult = null;
    var vIterator = 0;
    while (!vBrandFound && vIterator < gObjectCarData.length) {
      if (gObjectCarData[vIterator].brandId === paramBrandId) {
        vBrandFound = true;
        vBrandTypesResult = gObjectCarData[vIterator].brandTypes;
      }
      else {
        vIterator++;
      }
    }
    return vBrandTypesResult;
  }

  // 
  function thuThapDuLieu(paramType) {
    paramType.brandId = $("#car-select").val();
    paramType.brandName = $("#car-select option:selected").text();
    paramType.typeId = $("#car-type-select").val();
    paramType.typeName = $("#car-type-select option:selected").text();
  }
  //
  function valiDateSend(paramType)
  {
    if(paramType.brandId == 0)
    {
      alert("Ban chua chon Car");
      $("#car-select").focus();
      return false ;
    }
    if(paramType.typeId == -1)
    {
      alert("Ban chua chon Type")
      $("#car-type-select").focus();
      return false ;
    }
    return true ;
  }
  // show data
  function showDataCar(paramType)
  {
    console.log(paramType);
  }
</script>

</html>